diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/test/global-route-manager-impl-test-suite.cc ns-3.47/src/internet/test/global-route-manager-impl-test-suite.cc
--- ns-3.46/src/internet/test/global-route-manager-impl-test-suite.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/test/global-route-manager-impl-test-suite.cc	2026-02-16 16:08:49.623230000 -0800
@@ -15,10 +15,11 @@
 #include "ns3/candidate-queue.h"
 #include "ns3/config.h"
 #include "ns3/global-route-manager-impl.h"
+#include "ns3/global-routing.h"
 #include "ns3/internet-module.h"
 #include "ns3/internet-stack-helper.h"
 #include "ns3/ipv4-global-routing-helper.h"
-#include "ns3/ipv4-global-routing.h"
+#include "ns3/ipv6-global-routing-helper.h"
 #include "ns3/network-module.h"
 #include "ns3/node-container.h"
 #include "ns3/rng-seed-manager.h"
@@ -76,7 +77,24 @@
      *@brief Builds the LSAs for the topology. These LSAs are manually created and inserted into the
      * GlobalRouteManagerLSDB.Each node exports a router LSA.
      */
-    void BuildLsa();
+    void BuildLsav4();
+
+    /**
+     *@brief Builds the LSAs for the topology. These LSAs are manually created and inserted into the
+     * GlobalRouteManagerLSDB.Each node exports a router LSA.
+     */
+    void BuildLsav6();
+
+    /**
+     *  @brief Checks the Routing Table Entries for the expected output.
+     * @param globalroutingprotocol The routing protocol for the node whose routing table is to be
+     * checked.
+     * @param dests The expected destinations.
+     * @param gws The expected gateways.
+     */
+    void CheckRoutesv4(Ptr<Ipv4GlobalRouting>& globalroutingprotocol,
+                       std::vector<Ipv4Address>& dests,
+                       std::vector<Ipv4Address>& gws);
 
     /**
      *  @brief Checks the Routing Table Entries for the expected output.
@@ -85,12 +103,13 @@
      * @param dests The expected destinations.
      * @param gws The expected gateways.
      */
-    void CheckRoutes(Ptr<Ipv4GlobalRouting>& globalroutingprotocol,
-                     std::vector<Ipv4Address>& dests,
-                     std::vector<Ipv4Address>& gws);
+    void CheckRoutesv6(Ptr<Ipv6GlobalRouting>& globalroutingprotocol,
+                       std::vector<Ipv6Address>& dests,
+                       std::vector<Ipv6Address>& gws);
 
-    NodeContainer nodes;                   //!< NodeContainer to hold the nodes in the topology
-    std::vector<GlobalRoutingLSA*> m_lsas; //!< The LSAs for the topology
+    NodeContainer nodes; //!< NodeContainer to hold the nodes in the topology
+    std::vector<GlobalRoutingLSA<Ipv4Manager>*> m_lsasv4; //!< The LSAs for the topology
+    std::vector<GlobalRoutingLSA<Ipv6Manager>*> m_lsasv6; //!< The LSAs for the topology
 };
 
 LinkRoutesTestCase::LinkRoutesTestCase()
@@ -99,9 +118,9 @@
 }
 
 void
-LinkRoutesTestCase::CheckRoutes(Ptr<Ipv4GlobalRouting>& globalroutingprotocol,
-                                std::vector<Ipv4Address>& dests,
-                                std::vector<Ipv4Address>& gws)
+LinkRoutesTestCase::CheckRoutesv4(Ptr<Ipv4GlobalRouting>& globalroutingprotocol,
+                                  std::vector<Ipv4Address>& dests,
+                                  std::vector<Ipv4Address>& gws)
 {
     // check each individual Routing Table Entry for its destination and gateway
     for (uint32_t i = 0; i < globalroutingprotocol->GetNRoutes(); i++)
@@ -114,6 +133,21 @@
 }
 
 void
+LinkRoutesTestCase::CheckRoutesv6(Ptr<Ipv6GlobalRouting>& globalroutingprotocol,
+                                  std::vector<Ipv6Address>& dests,
+                                  std::vector<Ipv6Address>& gws)
+{
+    // check each individual Routing Table Entry for its destination and gateway
+    for (uint32_t i = 0; i < globalroutingprotocol->GetNRoutes(); i++)
+    {
+        Ipv6RoutingTableEntry* route = globalroutingprotocol->GetRoute(i);
+        NS_LOG_DEBUG("dest " << route->GetDest() << " gw " << route->GetGateway());
+        NS_TEST_ASSERT_MSG_EQ(route->GetDest(), dests[i], "Error-- wrong destination");
+        NS_TEST_ASSERT_MSG_EQ(route->GetGateway(), gws[i], "Error-- wrong gateway");
+    }
+}
+
+void
 LinkRoutesTestCase::DoSetup()
 {
     // Simple p2p links. n0,n1 and n3 are stub nodes
@@ -136,9 +170,11 @@
 
     nodes.Create(4);
 
-    Ipv4GlobalRoutingHelper globalhelper;
+    Ipv4GlobalRoutingHelper globalhelperv4;
+    Ipv6GlobalRoutingHelper globalhelperv6;
     InternetStackHelper stack;
-    stack.SetRoutingHelper(globalhelper);
+    stack.SetRoutingHelper(globalhelperv4);
+    stack.SetRoutingHelper(globalhelperv6);
     stack.Install(nodes);
 
     SimpleNetDeviceHelper devHelper;
@@ -161,87 +197,105 @@
     Ipv4InterfaceContainer i12 = address.Assign(d12);
     address.SetBase("10.1.3.0", "255.255.255.252");
     Ipv4InterfaceContainer i23 = address.Assign(d23);
+
+    Ipv6AddressHelper addressv6;
+    addressv6.SetBase("2001:1::", Ipv6Prefix(64));
+    Ipv6InterfaceContainer i02v6 = addressv6.Assign(d02);
+    addressv6.SetBase("2001:2::", Ipv6Prefix(64));
+    Ipv6InterfaceContainer i12v6 = addressv6.Assign(d12);
+    addressv6.SetBase("2001:3::", Ipv6Prefix(64));
+    Ipv6InterfaceContainer i23v6 = addressv6.Assign(d23);
 }
 
 void
-LinkRoutesTestCase::BuildLsa()
+LinkRoutesTestCase::BuildLsav4()
 {
     // Manually build the link state database; four routers (0-3), 3 point-to-point
     // links
 
     // Router 0
-    auto lr0 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                           "0.0.0.2",  // link id -> router ID 0.0.0.2
-                                           "10.1.1.1", // link data -> Local IP address of router 0
-                                           1);         // metric
-
-    auto lr1 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                           "10.1.1.2", // link id ->adjacent neighbor's IP address
-                                           "255.255.255.252",
-                                           1);
+    auto lr0 = new GlobalRoutingLinkRecord<Ipv4Manager>(
+        GlobalRoutingLinkRecord<Ipv4Manager>::PointToPoint,
+        "0.0.0.2",  // link id -> router ID 0.0.0.2
+        "10.1.1.1", // link data -> Local IP address of router 0
+        1);         // metric
+
+    auto lr1 = new GlobalRoutingLinkRecord<Ipv4Manager>(
+        GlobalRoutingLinkRecord<Ipv4Manager>::StubNetwork,
+        "10.1.1.2", // link id ->adjacent neighbor's IP address
+        "255.255.255.252",
+        1);
 
-    auto lsa0 = new GlobalRoutingLSA();
-    lsa0->SetLSType(GlobalRoutingLSA::RouterLSA);
+    auto lsa0 = new GlobalRoutingLSA<Ipv4Manager>();
+    lsa0->SetLSType(GlobalRoutingLSA<Ipv4Manager>::RouterLSA);
     lsa0->SetLinkStateId("0.0.0.0");
     lsa0->SetAdvertisingRouter("0.0.0.0");
     lsa0->SetNode(nodes.Get(0));
     lsa0->AddLinkRecord(lr0);
     lsa0->AddLinkRecord(lr1);
-    m_lsas.push_back(lsa0);
+    m_lsasv4.push_back(lsa0);
 
     // Router 1
-    auto lr2 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                           "0.0.0.2",
-                                           "10.1.2.1",
-                                           1);
-
-    auto lr3 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                           "10.1.2.2",
-                                           "255.255.255.252",
-                                           1);
+    auto lr2 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::PointToPoint,
+                                                 "0.0.0.2",
+                                                 "10.1.2.1",
+                                                 1);
+
+    auto lr3 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::StubNetwork,
+                                                 "10.1.2.2",
+                                                 "255.255.255.252",
+                                                 1);
 
-    auto lsa1 = new GlobalRoutingLSA();
-    lsa1->SetLSType(GlobalRoutingLSA::RouterLSA);
+    auto lsa1 = new GlobalRoutingLSA<Ipv4Manager>();
+    lsa1->SetLSType(GlobalRoutingLSA<Ipv4Manager>::RouterLSA);
     lsa1->SetLinkStateId("0.0.0.1");
     lsa1->SetAdvertisingRouter("0.0.0.1");
     lsa1->AddLinkRecord(lr2);
     lsa1->AddLinkRecord(lr3);
     lsa1->SetNode(nodes.Get(1));
-    m_lsas.push_back(lsa1);
+    m_lsasv4.push_back(lsa1);
 
     // Router 2
-    auto lr4 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                           "0.0.0.0",
-                                           "10.1.1.2",
-                                           1);
-
-    auto lr5 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                           "10.1.1.1",
-                                           "255.255.255.252",
-                                           1);
-
-    auto lr6 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                           "0.0.0.1",
-                                           "10.1.2.2",
-                                           1);
-
-    auto lr7 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                           "10.1.2.2",
-                                           "255.255.255.252",
-                                           1);
-
-    auto lr8 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                           "0.0.0.3",
-                                           "10.1.3.1",
-                                           1);
-
-    auto lr9 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                           "10.1.3.2",
-                                           "255.255.255.252",
-                                           1);
+    auto lr4 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::PointToPoint,
+                                                 "0.0.0.0",
+                                                 "10.1.1.2",
+                                                 1);
+
+    auto lr5 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::StubNetwork,
+                                                 "10.1.1.1",
+                                                 "255.255.255.252",
+                                                 1);
+
+    auto lr6 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::PointToPoint,
+                                                 "0.0.0.1",
+                                                 "10.1.2.2",
+                                                 1);
+
+    auto lr7 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::StubNetwork,
+                                                 "10.1.2.2",
+                                                 "255.255.255.252",
+                                                 1);
+
+    auto lr8 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::PointToPoint,
+                                                 "0.0.0.3",
+                                                 "10.1.3.1",
+                                                 1);
+
+    auto lr9 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::StubNetwork,
+                                                 "10.1.3.2",
+                                                 "255.255.255.252",
+                                                 1);
 
-    auto lsa2 = new GlobalRoutingLSA();
-    lsa2->SetLSType(GlobalRoutingLSA::RouterLSA);
+    auto lsa2 = new GlobalRoutingLSA<Ipv4Manager>();
+    lsa2->SetLSType(GlobalRoutingLSA<Ipv4Manager>::RouterLSA);
     lsa2->SetLinkStateId("0.0.0.2");
     lsa2->SetAdvertisingRouter("0.0.0.2");
     lsa2->AddLinkRecord(lr4);
@@ -251,27 +305,166 @@
     lsa2->AddLinkRecord(lr8);
     lsa2->AddLinkRecord(lr9);
     lsa2->SetNode(nodes.Get(2));
-    m_lsas.push_back(lsa2);
+    m_lsasv4.push_back(lsa2);
 
     // Router 3
-    auto lr10 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                            "0.0.0.2",
-                                            "10.1.3.2",
-                                            1);
-
-    auto lr11 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                            "10.1.3.1",
-                                            "255.255.255.252",
-                                            1);
+    auto lr10 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::PointToPoint,
+                                                 "0.0.0.2",
+                                                 "10.1.3.2",
+                                                 1);
+
+    auto lr11 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::StubNetwork,
+                                                 "10.1.3.1",
+                                                 "255.255.255.252",
+                                                 1);
 
-    auto lsa3 = new GlobalRoutingLSA();
-    lsa3->SetLSType(GlobalRoutingLSA::RouterLSA);
+    auto lsa3 = new GlobalRoutingLSA<Ipv4Manager>();
+    lsa3->SetLSType(GlobalRoutingLSA<Ipv4Manager>::RouterLSA);
     lsa3->SetLinkStateId("0.0.0.3");
     lsa3->SetAdvertisingRouter("0.0.0.3");
     lsa3->AddLinkRecord(lr10);
     lsa3->AddLinkRecord(lr11);
     lsa3->SetNode(nodes.Get(3));
-    m_lsas.push_back(lsa3);
+    m_lsasv4.push_back(lsa3);
+}
+
+void
+LinkRoutesTestCase::BuildLsav6()
+{
+    // Manually build the link state database; four routers (0-3), 3 point-to-point
+    // links
+
+    // Router 0
+    auto lr0 = new GlobalRoutingLinkRecord<Ipv6Manager>(
+        GlobalRoutingLinkRecord<Ipv6Manager>::PointToPoint,
+        "::ffff:0.0.0.2",        // link id -> router ID 0.0.0.2
+        "2001:1::200:ff:fe00:1", // link data -> Local GlobalUnicast IP address of router 0
+        "fe80::200:ff:fe00:1",   // Local Link Local IP address of router 0
+        1);                      // metric
+
+    // only need to do this once for prefix of 64 bits
+    uint8_t buf[16];
+    auto prefix = Ipv6Prefix(64);
+    prefix.GetBytes(buf); // frown
+
+    auto lr1 = new GlobalRoutingLinkRecord<Ipv6Manager>(
+        GlobalRoutingLinkRecord<Ipv6Manager>::StubNetwork,
+        "2001:1::200:ff:fe00:2", // link id ->adjacent neighbor's IP address
+        Ipv6Address(buf), // Link Data -> Prefix converted to Ipv6Address associated with neighbours
+                          // Ip address
+        1);
+
+    auto lsa0 = new GlobalRoutingLSA<Ipv6Manager>();
+    lsa0->SetLSType(GlobalRoutingLSA<Ipv6Manager>::RouterLSA);
+    lsa0->SetLinkStateId("::ffff:0.0.0.0");
+    lsa0->SetAdvertisingRouter("::ffff:0.0.0.0");
+    lsa0->SetNode(nodes.Get(0));
+    lsa0->AddLinkRecord(lr0);
+    lsa0->AddLinkRecord(lr1);
+    m_lsasv6.push_back(lsa0);
+
+    // Router 1
+    auto lr2 = new GlobalRoutingLinkRecord<Ipv6Manager>(
+        GlobalRoutingLinkRecord<Ipv6Manager>::PointToPoint,
+        "::ffff:0.0.0.2",        // link id -> router ID
+        "2001:2::200:ff:fe00:3", // link data -> Local Global Unicast IP address of router 1
+        "fe80::200:ff:fe00:3",   // link loc data -> Local Link Local IP address of router 1
+        1);
+
+    auto lr3 = new GlobalRoutingLinkRecord<Ipv6Manager>(
+        GlobalRoutingLinkRecord<Ipv6Manager>::StubNetwork,
+        "2001:2::200:ff:fe00:4", // link id ->adjacent neighbor's IP address
+        Ipv6Address(buf), // Link Data -> Prefix converted to Ipv6Address associated with neighbours
+                          // Ip address
+        1);
+
+    auto lsa1 = new GlobalRoutingLSA<Ipv6Manager>();
+    lsa1->SetLSType(GlobalRoutingLSA<Ipv6Manager>::RouterLSA);
+    lsa1->SetLinkStateId("::ffff:0.0.0.1");
+    lsa1->SetAdvertisingRouter("::ffff:0.0.0.1");
+    lsa1->AddLinkRecord(lr2);
+    lsa1->AddLinkRecord(lr3);
+    lsa1->SetNode(nodes.Get(1));
+    m_lsasv6.push_back(lsa1);
+
+    // Router 2
+    auto lr4 = new GlobalRoutingLinkRecord<Ipv6Manager>(
+        GlobalRoutingLinkRecord<Ipv6Manager>::PointToPoint,
+        "::ffff:0.0.0.0",        // link id -> router ID
+        "2001:1::200:ff:fe00:2", // link data -> Local Global Unicast IP address of router 2
+        "fe80::200:ff:fe00:2",   // link loc data -> Local Link Local IP address of router 2
+        1);
+
+    auto lr5 = new GlobalRoutingLinkRecord<Ipv6Manager>(
+        GlobalRoutingLinkRecord<Ipv6Manager>::StubNetwork,
+        "2001:1::200:ff:fe00:1", // link id ->adjacent neighbor's IP address
+        Ipv6Address(buf), // Link Data -> Prefix converted to Ipv6Address associated with neighbours
+                          // Ip address
+        1);
+
+    auto lr6 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::PointToPoint,
+                                                 "::ffff:0.0.0.1",
+                                                 "2001:2::200:ff:fe00:4",
+                                                 "fe80::200:ff:fe00:4",
+                                                 1);
+
+    auto lr7 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::StubNetwork,
+                                                 "2001:2::200:ff:fe00:3",
+                                                 Ipv6Address(buf),
+                                                 1);
+
+    auto lr8 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::PointToPoint,
+                                                 "::ffff:0.0.0.3",
+                                                 "2001:3::200:ff:fe00:5",
+                                                 "fe80::200:ff:fe00:5",
+                                                 1);
+
+    auto lr9 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::StubNetwork,
+                                                 "2001:3::200:ff:fe00:6",
+                                                 Ipv6Address(buf),
+                                                 1);
+
+    auto lsa2 = new GlobalRoutingLSA<Ipv6Manager>();
+    lsa2->SetLSType(GlobalRoutingLSA<Ipv6Manager>::RouterLSA);
+    lsa2->SetLinkStateId("::ffff:0.0.0.2");
+    lsa2->SetAdvertisingRouter("::ffff:0.0.0.2");
+    lsa2->AddLinkRecord(lr4);
+    lsa2->AddLinkRecord(lr5);
+    lsa2->AddLinkRecord(lr6);
+    lsa2->AddLinkRecord(lr7);
+    lsa2->AddLinkRecord(lr8);
+    lsa2->AddLinkRecord(lr9);
+    lsa2->SetNode(nodes.Get(2));
+    m_lsasv6.push_back(lsa2);
+
+    // Router 3
+    auto lr10 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::PointToPoint,
+                                                 "::ffff:0.0.0.2",
+                                                 "2001:3::200:ff:fe00:6",
+                                                 "fe80::200:ff:fe00:6",
+                                                 1);
+
+    auto lr11 =
+        new GlobalRoutingLinkRecord<Ipv6Manager>(GlobalRoutingLinkRecord<Ipv6Manager>::StubNetwork,
+                                                 "2001:3::200:ff:fe00:5",
+                                                 Ipv6Address(buf),
+                                                 1);
+
+    auto lsa3 = new GlobalRoutingLSA<Ipv6Manager>();
+    lsa3->SetLSType(GlobalRoutingLSA<Ipv6Manager>::RouterLSA);
+    lsa3->SetLinkStateId("::ffff:0.0.0.3");
+    lsa3->SetAdvertisingRouter("::ffff:0.0.0.3");
+    lsa3->AddLinkRecord(lr10);
+    lsa3->AddLinkRecord(lr11);
+    lsa3->SetNode(nodes.Get(3));
+    m_lsasv6.push_back(lsa3);
 }
 
 void
@@ -285,38 +478,65 @@
     //  This is a manual setup of the LSAs, which would normally be done by the
     //  GlobalRoutingHelper.
 
-    BuildLsa();
+    BuildLsav4();
 
     // Test the database
-    auto srmlsdb = new GlobalRouteManagerLSDB();
-    srmlsdb->Insert(m_lsas[0]->GetLinkStateId(), m_lsas[0]);
-    srmlsdb->Insert(m_lsas[1]->GetLinkStateId(), m_lsas[1]);
-    srmlsdb->Insert(m_lsas[2]->GetLinkStateId(), m_lsas[2]);
-    srmlsdb->Insert(m_lsas[3]->GetLinkStateId(), m_lsas[3]);
+    auto srmlsdb = new GlobalRouteManagerLSDB<Ipv4Manager>();
+    srmlsdb->Insert(m_lsasv4[0]->GetLinkStateId(), m_lsasv4[0]);
+    srmlsdb->Insert(m_lsasv4[1]->GetLinkStateId(), m_lsasv4[1]);
+    srmlsdb->Insert(m_lsasv4[2]->GetLinkStateId(), m_lsasv4[2]);
+    srmlsdb->Insert(m_lsasv4[3]->GetLinkStateId(), m_lsasv4[3]);
 
     NS_TEST_ASSERT_MSG_EQ(
-        m_lsas[2],
-        srmlsdb->GetLSA(m_lsas[2]->GetLinkStateId()),
+        m_lsasv4[2],
+        srmlsdb->GetLSA(m_lsasv4[2]->GetLinkStateId()),
         "The Ipv4Address is not stored as the link state ID"); // LSAs are mapped by router id as
                                                                // key here we check that they are
                                                                // indeed getting the right lsa for
                                                                // the right key
 
     // next, calculate routes based on the manually created LSDB
-    auto srm = new GlobalRouteManagerImpl();
+    auto srm = new GlobalRouteManagerImpl<Ipv4Manager>();
     srm->DebugUseLsdb(srmlsdb); // manually add in an LSDB
 
-    srm->DebugSPFCalculate(m_lsas[0]->GetLinkStateId()); // fill routing table for node n0
+    srm->DebugSPFCalculate(m_lsasv4[0]->GetLinkStateId()); // fill routing table for node n0
 
-    srm->DebugSPFCalculate(m_lsas[1]->GetLinkStateId()); // fill routing table for node n1
+    srm->DebugSPFCalculate(m_lsasv4[1]->GetLinkStateId()); // fill routing table for node n1
 
-    srm->DebugSPFCalculate(m_lsas[2]->GetLinkStateId()); // fill routing table for node n2
+    srm->DebugSPFCalculate(m_lsasv4[2]->GetLinkStateId()); // fill routing table for node n2
 
-    srm->DebugSPFCalculate(m_lsas[3]->GetLinkStateId()); // fill routing table for node n3
+    srm->DebugSPFCalculate(m_lsasv4[3]->GetLinkStateId()); // fill routing table for node n3
 
-    Simulator::Run();
+    BuildLsav6();
+
+    // Test the database
+    auto srmlsdbv6 = new GlobalRouteManagerLSDB<Ipv6Manager>();
+    srmlsdbv6->Insert(m_lsasv6[0]->GetLinkStateId(), m_lsasv6[0]);
+    srmlsdbv6->Insert(m_lsasv6[1]->GetLinkStateId(), m_lsasv6[1]);
+    srmlsdbv6->Insert(m_lsasv6[2]->GetLinkStateId(), m_lsasv6[2]);
+    srmlsdbv6->Insert(m_lsasv6[3]->GetLinkStateId(), m_lsasv6[3]);
+
+    NS_TEST_ASSERT_MSG_EQ(
+        m_lsasv6[2],
+        srmlsdbv6->GetLSA(m_lsasv6[2]->GetLinkStateId()),
+        "The Ipv6Address is not stored as the link state ID"); // LSAs are mapped by router id as
+                                                               // key here we check that they are
+                                                               // indeed getting the right lsa for
+                                                               // the right key
+
+    // next, calculate routes based on the manually created LSDB
+    auto srmv6 = new GlobalRouteManagerImpl<Ipv6Manager>();
+    srmv6->DebugUseLsdb(srmlsdbv6); // manually add in an LSDB
+
+    srmv6->DebugSPFCalculate(m_lsasv6[0]->GetLinkStateId()); // fill ipv6 routing table for node n0
+
+    srmv6->DebugSPFCalculate(m_lsasv6[1]->GetLinkStateId()); // fill ipv6 routing table for node n1
 
-    //-----------------Now the tests------------------
+    srmv6->DebugSPFCalculate(m_lsasv6[2]->GetLinkStateId()); // fill ipv6 routing table for node n2
+
+    srmv6->DebugSPFCalculate(m_lsasv6[3]->GetLinkStateId()); // fill ipv6 routing table for node n3
+
+    //-----------------Now the tests for Ipv4------------------
     // Test 1: Check if the SPF calculate Sets default routes for Stub nodes
     Ptr<Ipv4L3Protocol> ip0 = nodes.Get(0)->GetObject<Ipv4L3Protocol>();
     NS_TEST_ASSERT_MSG_NE(ip0, nullptr, "Error-- no Ipv4 object at node 0");
@@ -367,7 +587,66 @@
     expectedgws.emplace_back("10.1.2.1");
     expectedgws.emplace_back("10.1.3.2");
 
-    CheckRoutes(globalRouting2, expecteddests, expectedgws);
+    CheckRoutesv4(globalRouting2, expecteddests, expectedgws);
+
+    //-----------------Now the tests for Ipv6------------------
+    // Test 1: Check if the SPF calculate Sets default routes for Stub nodes
+    Ptr<Ipv6L3Protocol> ip0v6 = nodes.Get(0)->GetObject<Ipv6L3Protocol>();
+    NS_TEST_ASSERT_MSG_NE(ip0v6, nullptr, "Error-- no Ipv6 object at node 0");
+    Ptr<Ipv6RoutingProtocol> routing0v6 = ip0v6->GetRoutingProtocol();
+    NS_TEST_ASSERT_MSG_NE(routing0v6, nullptr, "Error-- no Ipv6 routing protocol object at node 0");
+    Ptr<Ipv6GlobalRouting> globalRouting0v6 = routing0v6->GetObject<Ipv6GlobalRouting>();
+    NS_TEST_ASSERT_MSG_NE(globalRouting0v6,
+                          nullptr,
+                          "Error-- no Ipv6GlobalRouting object at node 0");
+
+    // Check that the right number of entries are in the routing table
+    uint32_t nRoutes0v6 = globalRouting0v6->GetNRoutes();
+    NS_TEST_ASSERT_MSG_EQ(nRoutes0v6, 1, "Error-- default route not found for stub node");
+
+    Ipv6RoutingTableEntry* routev6 = nullptr;
+    routev6 = globalRouting0v6->GetRoute(0);
+    // the only route is the default route on this node
+    NS_TEST_ASSERT_MSG_EQ(routev6->GetDest(),
+                          Ipv6Address("::"),
+                          "Error-- wrong destination for default route");
+    NS_TEST_ASSERT_MSG_EQ(routev6->GetGateway(),
+                          Ipv6Address("fe80::200:ff:fe00:2"),
+                          "Error-- wrong gateway");
+
+    // Test 2: Check if SPFCalculate sets the correct routes for node 2
+    Ptr<Ipv6L3Protocol> ip2v6 = nodes.Get(2)->GetObject<Ipv6L3Protocol>();
+    NS_TEST_ASSERT_MSG_NE(ip2v6, nullptr, "Error-- no Ipv6 object at node 2");
+    Ptr<Ipv6RoutingProtocol> routing2v6 = ip2v6->GetRoutingProtocol();
+    NS_TEST_ASSERT_MSG_NE(routing2v6, nullptr, "Error-- no Ipv6 routing protocol object at node 2");
+    Ptr<Ipv6GlobalRouting> globalRouting2v6 = routing2v6->GetObject<Ipv6GlobalRouting>();
+    NS_TEST_ASSERT_MSG_NE(globalRouting2v6,
+                          nullptr,
+                          "Error-- no Ipv6GlobalRouting object at node 2");
+
+    // check that the correct number of routes were built
+    uint32_t nRoutes2v6 = globalRouting2v6->GetNRoutes();
+    NS_LOG_DEBUG("LinkRoutesTest nRoutes2 " << nRoutes2v6);
+    NS_TEST_ASSERT_MSG_EQ(nRoutes2v6, 6, "Error--- Incorrect number of routes found on node 2");
+
+    // check that all the routes in the routing table are correct for node 2
+    std::vector<Ipv6Address> expecteddestsv6;
+    std::vector<Ipv6Address> expectedgwsv6;
+    expecteddestsv6.emplace_back("2001:1::200:ff:fe00:1");
+    expecteddestsv6.emplace_back("2001:2::200:ff:fe00:3");
+    expecteddestsv6.emplace_back("2001:3::200:ff:fe00:6");
+    expecteddestsv6.emplace_back("2001:1::");
+    expecteddestsv6.emplace_back("2001:2::");
+    expecteddestsv6.emplace_back("2001:3::");
+
+    expectedgwsv6.emplace_back("fe80::200:ff:fe00:1");
+    expectedgwsv6.emplace_back("fe80::200:ff:fe00:3");
+    expectedgwsv6.emplace_back("fe80::200:ff:fe00:6");
+    expectedgwsv6.emplace_back("fe80::200:ff:fe00:1");
+    expectedgwsv6.emplace_back("fe80::200:ff:fe00:3");
+    expectedgwsv6.emplace_back("fe80::200:ff:fe00:6");
+
+    CheckRoutesv6(globalRouting2v6, expecteddestsv6, expectedgwsv6);
 
     Simulator::Run();
 
@@ -377,9 +656,11 @@
     // This delete clears the srm, which deletes the LSDB, which clears
     // all of the LSAs, which each destroys the attached LinkRecords.
     delete srm;
+    delete srmv6;
     // reset the router ID counter to zero so that it does not affect other tests
     //  that may run after this one in the same program run.
-    GlobalRouteManager::ResetRouterId();
+    GlobalRouteManager<Ipv4Manager>::ResetRouterId();
+    GlobalRouteManager<Ipv6Manager>::ResetRouterId();
 }
 
 /**
@@ -397,14 +678,22 @@
 
   private:
     /**
-     *@brief Builds the LSAs for the topology. These LSAs are manually created and inserted into the
-     * GlobalRouteManagerLSDB.Each node exports a router LSA. In addition,the designated router
-     * also Exports the Network LSA.
+     *@brief Builds the ipv4 LSAs for the topology. These LSAs are manually created and inserted
+     *into the GlobalRouteManagerLSDB.Each node exports a router LSA. In addition,the designated
+     *router also Exports the Network LSA.
+     */
+    void BuildLsav4();
+
+    /**
+     *@brief Builds the ipv6 LSAs for the topology. These LSAs are manually created and inserted
+     *into the GlobalRouteManagerLSDB.Each node exports a router LSA. In addition,the designated
+     *router also Exports the Network LSA.
      */
-    void BuildLsa();
+    void BuildLsav6();
 
-    NodeContainer nodes;                   //!< NodeContainer to hold the nodes in the topology
-    std::vector<GlobalRoutingLSA*> m_lsas; //!< The LSAs for the topology
+    NodeContainer nodes; //!< NodeContainer to hold the nodes in the topology
+    std::vector<GlobalRoutingLSA<Ipv4Manager>*> m_lsasv4; //!< The ipv4 LSAs for the topology
+    std::vector<GlobalRoutingLSA<Ipv6Manager>*> m_lsasv6; //!< The ipv6 LSAs for the topology
 };
 
 LanRoutesTestCase::LanRoutesTestCase()
@@ -427,9 +716,11 @@
     //       n1:10.1.1.2/29
     //       n2:10.1.1.3/29
     nodes.Create(3);
-    Ipv4GlobalRoutingHelper globalhelper;
+    Ipv4GlobalRoutingHelper globalhelperv4;
+    Ipv6GlobalRoutingHelper globalhelperv6;
     InternetStackHelper stack;
-    stack.SetRoutingHelper(globalhelper);
+    stack.SetRoutingHelper(globalhelperv4);
+    stack.SetRoutingHelper(globalhelperv6);
     stack.Install(nodes);
     SimpleNetDeviceHelper devHelper;
     Ptr<SimpleChannel> channel = CreateObject<SimpleChannel>();
